/**
 * DsmlMessage.java
 *
 * File generated from the core::DsmlMessage uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class DsmlMessage.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "DsmlMessage", propOrder = {
	"control",
	"requestID"
})
@XmlRootElement(name = "DsmlMessage")
public class DsmlMessage extends net.ihe.gazelle.gen.common.CommonOperations implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "control", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public List<net.ihe.gazelle.hpd.Control> control;
	@XmlAttribute(name = "requestID")
	public java.lang.String requestID;
	
	public DsmlMessage(){
		this.requestID = generateId();
	}
	
	private String generateId(){
		Random r = new Random();
		int value = 1 + r.nextInt(5000);
		return Integer.toString(value);
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return control.
	 * @return control
	 */
	public List<net.ihe.gazelle.hpd.Control> getControl() {
		if (control == null) {
	        control = new ArrayList<net.ihe.gazelle.hpd.Control>();
	    }
	    return control;
	}
	
	/**
	 * Set a value to attribute control.
	 * @param control.
	 */
	public void setControl(List<net.ihe.gazelle.hpd.Control> control) {
	    this.control = control;
	}
	
	
	
	/**
	 * Add a control to the control collection.
	 * @param control_elt Element to add.
	 */
	public void addControl(net.ihe.gazelle.hpd.Control control_elt) {
	    this.getControl().add(control_elt);
	}
	
	/**
	 * Remove a control to the control collection.
	 * @param control_elt Element to remove
	 */
	public void removeControl(net.ihe.gazelle.hpd.Control control_elt) {
	    this.getControl().remove(control_elt);
	}
	
	/**
	 * Return requestID.
	 * @return requestID
	 */
	public java.lang.String getRequestID() {
	    return requestID;
	}
	
	/**
	 * Set a value to attribute requestID.
	 * @param requestID.
	 */
	public void setRequestID(java.lang.String requestID) {
	    this.requestID = requestID;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "DsmlMessage").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(DsmlMessage dsmlMessage, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (dsmlMessage != null){
   			cvm.validate(dsmlMessage, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.Control control: dsmlMessage.getControl()){
					net.ihe.gazelle.hpd.Control.validateByModule(control, _location + "/control[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}